"use strict";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var MIN_START_INDEX = 1;

var ViewPortList = function ViewPortList(_ref) {
  var _ref$viewPortRef = _ref.viewPortRef,
      viewPortRef = _ref$viewPortRef === void 0 ? {
    current: document.documentElement
  } : _ref$viewPortRef,
      _ref$listLength = _ref.listLength,
      listLength = _ref$listLength === void 0 ? 0 : _ref$listLength,
      _ref$itemMinHeight = _ref.itemMinHeight,
      itemMinHeight = _ref$itemMinHeight === void 0 ? 1 : _ref$itemMinHeight,
      _ref$margin = _ref.margin,
      margin = _ref$margin === void 0 ? 0 : _ref$margin,
      _ref$overscan = _ref.overscan,
      overscan = _ref$overscan === void 0 ? 0 : _ref$overscan,
      _ref$scrollToIndex = _ref.scrollToIndex,
      scrollToIndex = _ref$scrollToIndex === void 0 ? -1 : _ref$scrollToIndex,
      _ref$children = _ref.children,
      children = _ref$children === void 0 ? null : _ref$children;
  var itemMinHeightWithMargin = itemMinHeight + margin;

  var _useState = (0, _react.useState)(MIN_START_INDEX),
      _useState2 = _slicedToArray(_useState, 2),
      startIndex = _useState2[0],
      setStartIndex = _useState2[1];

  var _useState3 = (0, _react.useState)(0),
      _useState4 = _slicedToArray(_useState3, 2),
      maxVisibleItemsCount = _useState4[0],
      setMaxVisibleItemsCount = _useState4[1];

  var maxIndex = listLength - 2;
  var maxStartIndex = Math.max(maxIndex - maxVisibleItemsCount, MIN_START_INDEX);
  var normalizedStartIndex = Math.min(startIndex, maxStartIndex);
  var endIndex = Math.min(normalizedStartIndex + maxVisibleItemsCount, maxIndex);
  var startRef = (0, _react.useRef)(null);
  var scrollRef = (0, _react.useRef)(null);
  var variables = (0, _react.useRef)({
    scrolledToIndex: -1,
    inc: 1,
    dec: 1,
    stepFunc: function stepFunc() {},
    cache: []
  });

  variables.current.stepFunc = function () {
    if (!viewPortRef.current) {
      variables.current.inc = 1;
      variables.current.dec = 1;
      return;
    }

    var viewPortRefRect = viewPortRef.current.getBoundingClientRect();
    setMaxVisibleItemsCount(Math.ceil(viewPortRefRect.height / itemMinHeightWithMargin) + Math.ceil(overscan / itemMinHeightWithMargin) * 2);

    if (startIndex !== normalizedStartIndex) {
      setStartIndex(normalizedStartIndex);
      variables.current.inc = 1;
      variables.current.dec = 1;
      return;
    }

    if (scrollToIndex !== variables.current.scrolledToIndex) {
      variables.current.inc = 1;
      variables.current.dec = 1;

      if (scrollToIndex < 0 || scrollToIndex > listLength - 1) {
        variables.current.scrolledToIndex = scrollToIndex;
        return;
      }

      var targetIndex = Math.min(Math.max(scrollToIndex - Math.ceil(overscan / itemMinHeightWithMargin), MIN_START_INDEX), maxStartIndex);

      if (startIndex === targetIndex && (scrollRef.current || startRef.current)) {
        (scrollRef.current || startRef.current).scrollIntoView();
        variables.current.scrolledToIndex = scrollToIndex;
        return;
      }

      setStartIndex(targetIndex);
      return;
    }

    if (!startRef.current || listLength <= maxVisibleItemsCount) {
      variables.current.inc = 1;
      variables.current.dec = 1;
      return;
    }

    var startRefRect = startRef.current.getBoundingClientRect();
    var topLimit = viewPortRefRect.top - overscan;
    variables.current.cache[startIndex] = startRefRect.height - itemMinHeight;

    if (startRefRect.bottom < topLimit) {
      setStartIndex(Math.min(startIndex + variables.current.inc, maxStartIndex));
      variables.current.inc = variables.current.inc * 2;
      variables.current.dec = 1;
      return;
    }

    if (startRefRect.top > topLimit) {
      setStartIndex(Math.max(startIndex - variables.current.dec, MIN_START_INDEX));
      variables.current.inc = 1;
      variables.current.dec = variables.current.dec * 2;
      return;
    }

    variables.current.inc = 1;
    variables.current.dec = 1;
  };

  (0, _react.useEffect)(function () {
    var frameId = 0;

    var frame = function frame() {
      frameId = requestAnimationFrame(frame);
      variables.current.stepFunc();
    };

    frame();
    return function () {
      return cancelAnimationFrame(frameId);
    };
  }, []);
  var items = (0, _react.useMemo)(function () {
    if (!children) {
      return false;
    }

    var result = [];

    if (listLength > 0) {
      result.push(children({
        innerRef: 0 === scrollToIndex ? scrollRef : undefined,
        index: 0,
        style: {
          marginBottom: Math.max(normalizedStartIndex - 1, 0) * itemMinHeightWithMargin + margin + variables.current.cache.slice(0, normalizedStartIndex).reduce(function (acc, curr) {
            return acc + curr;
          }, 0)
        }
      }));
    }

    for (var index = normalizedStartIndex; index <= endIndex; ++index) {
      result.push(children({
        innerRef: index === normalizedStartIndex ? startRef : index === scrollToIndex ? scrollRef : undefined,
        index: index,
        style: {
          marginBottom: margin
        }
      }));
    }

    if (listLength > 1) {
      result.push(children({
        innerRef: listLength - 1 === scrollToIndex ? scrollRef : undefined,
        index: listLength - 1,
        style: {
          marginTop: Math.max(maxIndex - endIndex, 0) * itemMinHeightWithMargin + margin
        }
      }));
    }

    return result;
  }, [children, endIndex, itemMinHeightWithMargin, listLength, margin, maxIndex, normalizedStartIndex, scrollToIndex]);
  return _react.default.createElement(_react.Fragment, null, items);
};

var _default = ViewPortList;
exports.default = _default;